var debounce = require("./debounce");

function _hasChanged(from, to) {
  for (var key in from) {
    if (from[key] !== to[key]) return true;
  }
  return false;
}

module.exports = {

  /**
   */

  componentDidMount: function() {
    this._watch();
  },

  /**
   */

  componentWillUpdate: function() {
    this._watch();
  },

  /**
   */

  shouldComponentUpdate: function(nextProps, nextState) {
    return _hasChanged(this.props, nextProps) ||
    _hasChanged(nextProps, this.props)        ||
    _hasChanged(this.state, nextState)        ||
    _hasChanged(nextState, this.state);
  },

  /**
   */

  componentWillUnmount: function() {
    this._unwatch();
  },

  /**
   */

  _watch: function() {
    this._unwatch();
    this._watchers = [];
    this._watchDict(this.props);
    this._watchDict(this.state);
  },

  /**
   */

  _watchDict: function(dict) {
    var forceUpdate = debounce(this.forceUpdate.bind(this, null), 10);
    for (var key in dict) {
      var value = dict[key];

      /* istanbul ignore else */
      if (value && value.__isWatchableObject) {
        this._watchers.push(dict[key].watch(forceUpdate));
      }
    }
  },

  /**
   */

  _unwatch: function() {
    if (this._watchers)
    for (var i = this._watchers.length; i--;) {
      this._watchers[i].dispose();
    }
    this._watchers = void 0;
  }
};
